//+------------------------------------------------------------------+
//|                                                   SafeZoneV2.mq5 |
//|                                      Copyright  2009, CoreWinTT | 
//|                                                                  |
//+------------------------------------------------------------------+
//----  
#property copyright "Copyright  2009, CoreWinTT"
//----  
#property link      ""
//----   
#property version   "1.00"
//----     
#property indicator_chart_window
//----        
#property indicator_buffers 2
//----    
#property indicator_plots   2
//+----------------------------------------------+
//|     1            |
//+----------------------------------------------+
//----   1   
#property indicator_type1   DRAW_LINE
//----         
#property indicator_color1  Red
//----   1 -  
#property indicator_style1  STYLE_SOLID
//----    1  1
#property indicator_width1  1
//----    
#property indicator_label1  "Upper SafeZoneV2"
//+----------------------------------------------+
//|     2            |
//+----------------------------------------------+
//----   2   
#property indicator_type2   DRAW_LINE
//----         
#property indicator_color2  Blue
//----   2 -  
#property indicator_style2  STYLE_SOLID
//----    2  1
#property indicator_width2  1
//----    
#property indicator_label2  "Lower SafeZoneV2"
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input uint Median=10;
input uint Max=52;
input uint MASAFE=3; 
input int Shift=0; //       
//+----------------------------------------------+
//----   ,    
//      
double DnBuffer[];
double UpBuffer[];
//----      
int min_rates_total;
//----   ,    
//      
int Count[];
double SRange[];
//+------------------------------------------------------------------+
//   CMoving_Average                                   |
//+------------------------------------------------------------------+
#include <SmoothAlgorithms.mqh> 
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+   
void Recount_ArrayZeroPos
(
 int &CoArr[]//        
 )
// Recount_ArrayZeroPos(count, Length)
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
  {
//----
   int numb,Max1,Max2;
   static int count=1;

   Max2=int(Max);
   Max1=Max2-1;

   count--;
   if(count<0) count=Max1;

   for(int iii=0; iii<Max2; iii++)
     {
      numb=iii+count;
      if(numb>Max1) numb-=Max2;
      CoArr[iii]=numb;
     }
//----
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
void OnInit()
  {
//----     
   min_rates_total=int(Median+Max+MASAFE);

//----       
   ArrayResize(Count,Max);
   ArrayResize(SRange,Max);
   
//----       
   ArraySetAsSeries(SRange,true);

//----   
   ArrayInitialize(SRange,0.0);

//----      
   SetIndexBuffer(0,DnBuffer,INDICATOR_DATA);
//----    1    Shift
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//----       1  min_rates_total
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);

//----      
   SetIndexBuffer(1,UpBuffer,INDICATOR_DATA);
//----    2    Shift
   PlotIndexSetInteger(1,PLOT_SHIFT,Shift);
//----       2  min_rates_total
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);

//----      
   string shortname;
   StringConcatenate(shortname,"SafeZoneV2(",Median,", ",Max,", ",MASAFE,", ",Shift,")");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//----
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double& high[],     //       
                const double& low[],      //        
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(rates_total<min_rates_total) return(0);

//----   
   int first,bar;
   double range,maximum,SmaH,SmaL;

   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first=0; //      
     }
   else first=prev_calculated-min_rates_total; //      

//----    CMoving_Average   SmoothAlgorithms.mqh 
   static CMoving_Average SMA,SMAH,SMAL;

//----    
   for(bar=first; bar<rates_total; bar++)
     {
      range=high[bar]-low[bar];
      SRange[Count[0]]=SMA.SMASeries(0,prev_calculated,rates_total,Median,range,bar,false);                 
      maximum=SRange[ArrayMaximum(SRange,0,WHOLE_ARRAY)];
      
      SmaH=SMAH.SMASeries(0,prev_calculated,rates_total,MASAFE,high[bar],bar,false);
      SmaL=SMAL.SMASeries(0,prev_calculated,rates_total,MASAFE,low[bar],bar,false);
      
      DnBuffer[bar]=SmaL-maximum;
      UpBuffer[bar]=SmaH+maximum;
      
      if(bar<rates_total-1) Recount_ArrayZeroPos(Count);
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
